<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <title>Chapitre 6. Construction du paquet</title>
    <link rel="stylesheet" type="text/css" href="debian.css"/>
    <meta name="generator" content="DocBook XSL Stylesheets V1.78.1"/>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
    <link rel="home" href="index.fr.html" title="Guide du nouveau responsable Debian"/>
    <link rel="up" href="index.fr.html" title="Guide du nouveau responsable Debian"/>
    <link rel="prev" href="dother.fr.html" title="Chapitre 5. Autres fichiers dans le répertoire debian"/>
    <link rel="next" href="checkit.fr.html" title="Chapitre 7. Contrôle des erreurs du paquet"/>
  </head>
  <body>
    <div class="navheader">
      <table width="100%" summary="Navigation header">
        <tr>
          <th colspan="3" align="center">Chapitre 6. Construction du paquet</th>
        </tr>
        <tr>
          <td align="left"><a accesskey="p" href="dother.fr.html"><img src="images/prev.png" alt="Précédent"/></a> </td>
          <th width="60%" align="center"> </th>
          <td align="right"> <a accesskey="n" href="checkit.fr.html"><img src="images/next.png" alt="Suivant"/></a></td>
        </tr>
      </table>
      <hr/>
    </div>
    <div class="chapter">
      <div class="titlepage">
        <div>
          <div>
            <h1 class="title"><a id="build"/>Chapitre 6. Construction du paquet</h1>
          </div>
        </div>
      </div>
      <div class="toc">
        <p>
          <strong>Table des matières</strong>
        </p>
        <dl class="toc">
          <dt>
            <span class="section">
              <a href="build.fr.html#completebuild">6.1. Reconstruction complète</a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="build.fr.html#autobuilder">6.2. Serveurs d'empaquetage automatique (« autobuilder »)</a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="build.fr.html#debuild">6.3. Commande <span class="command"><strong>debuild</strong></span></a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="build.fr.html#pbuilder">6.4. Paquet <code class="systemitem">pbuilder</code></a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="build.fr.html#git-buildpackage">6.5. Commande <span class="command"><strong>git-buildpackage</strong></span> et similaires</a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="build.fr.html#quickrebuild">6.6. Reconstruction rapide</a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="build.fr.html#hierarchy">6.7. Hiérarchie des commandes</a>
            </span>
          </dt>
        </dl>
      </div>
      <p>
Tout devrait maintenant être prêt pour construire le paquet.
</p>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="completebuild"/>6.1. Reconstruction complète</h2>
            </div>
          </div>
        </div>
        <p>
Pour réaliser correctement la reconstruction complète d'un paquet, doivent
être installés :
</p>
        <div class="itemizedlist">
          <ul class="itemizedlist">
            <li class="listitem">
              <p>
le paquet <code class="systemitem">build-essential</code> ;
</p>
            </li>
            <li class="listitem">
              <p>
les paquets énumérés dans le champ <code class="literal">Build-Depends</code>
(consultez <a class="xref" href="dreq.fr.html#control" title="4.1. control">Section 4.1, « <code class="filename">control</code> »</a>) ;
</p>
            </li>
            <li class="listitem">
              <p>
les paquets énumérés dans le champ <code class="literal">Build-Depends-indep</code>
(consultez <a class="xref" href="dreq.fr.html#control" title="4.1. control">Section 4.1, « <code class="filename">control</code> »</a>).
</p>
            </li>
          </ul>
        </div>
        <p>
Ensuite, exécutez la commande suivante dans le répertoire des sources :
</p>
        <pre class="screen">
$ dpkg-buildpackage -us -uc
</pre>
        <p>
Cela fera tout le nécessaire pour créer entièrement les paquets binaires et
source à votre place :
</p>
        <div class="itemizedlist">
          <ul class="itemizedlist">
            <li class="listitem">
              <p>
nettoyage de l'arbre des sources (<code class="literal">debian/rules clean</code>) ;
</p>
            </li>
            <li class="listitem">
              <p>
construction du paquet source (<code class="literal">dpkg-source -b</code>) ;
</p>
            </li>
            <li class="listitem">
              <p>
construction du programme (<code class="literal">debian/rules build</code>) ;
</p>
            </li>
            <li class="listitem">
              <p>
construction des paquets binaires (<code class="literal">fakeroot debian/rules
binary</code>) ;
</p>
            </li>
            <li class="listitem">
              <p>
création du fichier <code class="filename">.dsc</code> ;
</p>
            </li>
            <li class="listitem">
              <p>
création du fichier <code class="filename">.changes</code>, en utilisant
<span class="command"><strong>dpkg-genchanges</strong></span>.
</p>
            </li>
          </ul>
        </div>
        <p>
Si le résultat de la construction est satisfaisant, signez les fichiers
<code class="filename">.dsc</code> et <code class="filename">.changes</code> avec votre clef
privée GPG avec la commande <span class="command"><strong>debsign</strong></span>. Vous devez entrer
votre phrase secrète deux fois. <a href="#ftn.idp39606512" class="footnote" id="idp39606512"><sup class="footnote">[64]</sup></a>
</p>
        <p>
Pour un paquet Debian non natif, par exemple <code class="systemitem">gentoo</code>, vous verrez les fichiers suivants dans
le répertoire parent (<code class="filename">~/gentoo</code>) après la construction
des paquets : 
</p>
        <div class="itemizedlist">
          <ul class="itemizedlist">
            <li class="listitem">
              <p>
<code class="filename">gentoo_0.9.12.orig.tar.gz</code>
</p>
              <p>
c'est le code source amont d'origine, simplement renommé pour être conforme
aux normes Debian. Il a été créé au début avec <code class="literal">dh_make -f
../gentoo-0.9.12.tar.gz</code> ;
</p>
            </li>
            <li class="listitem">
              <p>
<code class="filename">gentoo_0.9.12-1.dsc</code>
</p>
              <p>
c'est un résumé du contenu du code source. Il est créé à partir du fichier
<code class="filename">control</code>, et est utilisé pour décompresser les sources
avec <span class="citerefentry"><span class="refentrytitle">dpkg-source</span>(1)</span>.
</p>
            </li>
            <li class="listitem">
              <p>
<code class="filename">gentoo_0.9.12-1.debian.tar.gz</code>
</p>
              <p>
cette archive compressée contient le répertoire
<code class="filename">debian</code>. Tous les ajouts et modifications au code source
d'origine sont conservés en tant que correctif <span class="command"><strong>quilt</strong></span> dans
<code class="filename">debian/patches</code>.
</p>
              <p>
Si quelqu'un d'autre veut recréer le paquet depuis le début, il peut
facilement le faire en utilisant ces trois fichiers. La procédure
d'extraction est facile : copier simplement ces trois fichiers quelque part
et exécuter <code class="literal">dpkg-source -x gentoo_0.9.12-1.dsc</code> ;
<a href="#ftn.idp39622032" class="footnote" id="idp39622032"><sup class="footnote">[65]</sup></a>
</p>
            </li>
            <li class="listitem">
              <p>
<code class="filename">gentoo_0.9.12-1_i386.deb</code>
</p>
              <p>
c'est le paquet binaire terminé. Vous pouvez utiliser
<span class="command"><strong>dpkg</strong></span> pour l'installer ou le retirer comme n'importe quel
autre paquet ;
</p>
            </li>
            <li class="listitem">
              <p>
<code class="filename">gentoo_0.9.12-1_i386.changes</code>
</p>
              <p>
ce fichier décrit toutes les modifications effectuées dans la révision
actuelle du paquet, et est utilisé par les programmes de maintenance des
archives FTP Debian pour y installer les paquets binaires et sources. Il est
partiellement créé à partir des fichiers <code class="filename">changelog</code> et
<code class="filename">.dsc</code>.
</p>
              <p>
Au fur et à mesure que vous travaillez sur le paquet, son comportement va
évoluer et de nouvelles fonctionnalités seront ajoutées. Les gens qui
téléchargent votre paquet peuvent lire ce fichier et voir rapidement ce qui
a changé. Les programmes de maintenance des archives Debian vont aussi
poster le contenu de ce fichier sur la liste de diffusion <a class="ulink" href="http://lists.debian.org/debian-devel-changes/">debian-devel-changes@lists.debian.org</a>.
</p>
            </li>
          </ul>
        </div>
        <p>
Les fichiers <code class="filename">gentoo_0.9.12-1.dsc</code> et
<code class="filename">gentoo_0.9.12-1_i386.changes</code> doivent être signés en
utilisant la commande <span class="command"><strong>debsign</strong></span> avec votre clef privée GPG
du répertoire <code class="filename">~/.gnupg/</code>, avant de les téléverser dans
l’archive FTP de Debian. La signature GPG fournit la preuve que ce sont
vraiment vos fichiers par l’utilisation de votre clef publique GPG.
</p>
        <p>
La commande <span class="command"><strong>debsign</strong></span> peut être utilisée pour signer avec
votre identifiant de clef secrète GPG (utile pour les paquets parrainés)
dans <code class="filename">~/.devscripts</code> comme suit :
</p>
        <pre class="screen">
DEBSIGN_KEYID=Votre_ID_de_clef_GPG
</pre>
        <p>
Les longues chaînes de chiffres dans les fichiers <code class="filename">.dsc</code>
et <code class="filename">.changes</code> sont les sommes SHA1 et SHA256 des fichiers
indiqués. Les personnes téléchargeant vos fichiers peuvent les vérifier avec
<span class="citerefentry"><span class="refentrytitle">sha1sum</span>(1)</span> ou <span class="citerefentry"><span class="refentrytitle">sha256sum</span>(1)</span>, et si les fichiers ne correspondent pas, elles sauront que
le fichier a été corrompu ou falsifié.
</p>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="autobuilder"/>6.2. Serveurs d'empaquetage automatique (« autobuilder »)</h2>
            </div>
          </div>
        </div>
        <p>
Debian gère de nombreux <a class="ulink" href="http://www.debian.org/ports/">portages</a> avec le <a class="ulink" href="http://www.debian.org/devel/buildd/">réseau de serveurs d'empaquetage automatique</a> faisant
fonctionner des démons <span class="command"><strong>buildd</strong></span> sur de nombreux ordinateurs
d'architectures différentes. Même si vous n'avez pas besoin de le faire
vous-même, vous devriez être au courant de ce qui va arriver à vos
paquets. La suite présente brièvement comment les paquets sont reconstruits
sur plusieurs architectures. <a href="#ftn.idp39645200" class="footnote" id="idp39645200"><sup class="footnote">[66]</sup></a>
</p>
        <p>
Les paquets <code class="literal">Architecture: any</code> sont reconstruits par les
serveurs d'empaquetage automatique. Seront installés :
</p>
        <div class="itemizedlist">
          <ul class="itemizedlist">
            <li class="listitem">
              <p>
le paquet <code class="systemitem">build-essential</code> ;
</p>
            </li>
            <li class="listitem">
              <p>
les paquets énumérés dans le champ <code class="literal">Build-Depends</code>,
(consultez <a class="xref" href="dreq.fr.html#control" title="4.1. control">Section 4.1, « <code class="filename">control</code> »</a>).
</p>
            </li>
          </ul>
        </div>
        <p>
Ensuite, la commande suivante est exécutée dans le répertoire des sources :
</p>
        <pre class="screen">
$ dpkg-buildpackage -B
</pre>
        <p>
Cela fera tout le nécessaire pour créer entièrement les paquets binaires
dépendants de l'architecture sur l'architecture concernée :
</p>
        <div class="itemizedlist">
          <ul class="itemizedlist">
            <li class="listitem">
              <p>
nettoyage de l'arbre des sources (<code class="literal">debian/rules clean</code>) ;
</p>
            </li>
            <li class="listitem">
              <p>
construction du programme (<code class="literal">debian/rules build</code>) ;
</p>
            </li>
            <li class="listitem">
              <p>
construction des paquets binaires dépendants de l'architecture
(<code class="literal">fakeroot debian/rules binary-arch</code>) ;
</p>
            </li>
            <li class="listitem">
              <p>
signature du fichier source <code class="filename">.dsc</code>, en utilisant
<span class="command"><strong>gpg</strong></span> ;
</p>
            </li>
            <li class="listitem">
              <p>
création et signature du fichier de téléchargement
<code class="filename">.changes</code>, en utilisant
<span class="command"><strong>dpkg-genchanges</strong></span> et <span class="command"><strong>gpg</strong></span>.
</p>
            </li>
          </ul>
        </div>
        <p>
C'est pourquoi votre paquet est disponible sur plusieurs architectures.
</p>
        <p>
Bien qu'il soit nécessaire d'installer les paquets énumérés dans le champ
<code class="literal">Build-Depends-Indep</code> pour l'empaquetage normal (consultez
<a class="xref" href="build.fr.html#completebuild" title="6.1. Reconstruction complète">Section 6.1, « Reconstruction complète »</a>), il n'est pas nécessaire de les installer
sur le serveur d'empaquetage automatique puisqu'il ne construit que les
paquets binaires dépendants de l'architecture. <a href="#ftn.idp39663088" class="footnote" id="idp39663088"><sup class="footnote">[67]</sup></a> Cette distinction entre l'empaquetage normal et celui des serveurs
d'empaquetage automatique permet de déterminer si les paquets doivent être
énumérés dans le champ <code class="literal">Build-Depends</code> ou
<code class="literal">Build-Depends-Indep</code> du fichier
<code class="filename">debian/control</code> (consultez <a class="xref" href="dreq.fr.html#control" title="4.1. control">Section 4.1, « <code class="filename">control</code> »</a>).
</p>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="debuild"/>6.3. Commande <span class="command"><strong>debuild</strong></span></h2>
            </div>
          </div>
        </div>
        <p>
Vous pouvez automatiser le processus de construction en utilisant la
commande <span class="command"><strong>dpkg-buildpackage</strong></span> et empaqueter ensuite avec la
commande <span class="command"><strong>debuild</strong></span>, consultez <span class="citerefentry"><span class="refentrytitle">debuild</span>(1)</span>.
</p>
        <p>
La commande <span class="command"><strong>dbuild</strong></span> exécute la commande
<span class="command"><strong>lintian</strong></span> pour une analyse statique après la construction
du paquet Debian. La commande <span class="command"><strong>lintian</strong></span> peut être
personnalisée dans <code class="filename">~/.devscripts</code> avec ce qui suit :
</p>
        <pre class="screen">
DEBUILD_DPKG_BUILDPACKAGE_OPTS="-us -uc -I -i"
DEBUILD_LINTIAN_OPTS="-i -I --show-overrides"
</pre>
        <p>
Le nettoyage des sources et la reconstruction du paquet avec un compte
utilisateur est aussi simple que :
</p>
        <pre class="screen">
$ debuild
</pre>
        <p>
Le nettoyage de l'arborescence des sources est aussi simple que :
</p>
        <pre class="screen">
$ debuild clean
</pre>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="pbuilder"/>6.4. Paquet <code class="systemitem">pbuilder</code></h2>
            </div>
          </div>
        </div>
        <p>
Pour un environnement de construction propre (<span class="command"><strong>chroot</strong></span>)
permettant de vérifier les dépendances de construction, <code class="systemitem">pbuilder</code> est très utile. <a href="#ftn.idp39680192" class="footnote" id="idp39680192"><sup class="footnote">[68]</sup></a> Cela garantit une construction propre des sources
en construction automatique sous <code class="literal">sid</code> pour différentes
architectures et évite une erreur sérieuse FTBFS (« Fails To Build From
Source » pour les échecs de construction à partir du paquet source), qui est
toujours en catégorie RC (« Release Critical », bloquant la
publication). <a href="#ftn.idp39682880" class="footnote" id="idp39682880"><sup class="footnote">[69]</sup></a>
</p>
        <p>
Le paquet <code class="systemitem">pbuilder</code> est
personnalisable de la manière suivante :
</p>
        <div class="itemizedlist">
          <ul class="itemizedlist">
            <li class="listitem">
              <p>
configuration du répertoire <code class="filename">/var/cache/pbuilder/result</code>
accessible en écriture pour l'utilisateur ;
</p>
            </li>
            <li class="listitem">
              <p>
création d'un répertoire, par exemple
<code class="filename"><em class="replaceable"><code>/var/cache/pbuilder/hooks</code></em></code>,
accessible en écriture pour l'utilisateur pour y placer ses scripts hook ;
</p>
            </li>
            <li class="listitem">
              <p>
configuration de <code class="filename">~/.pbuilderrc</code> ou
<code class="filename">/etc/pbuilderrc</code> pour intégrer ce qui suit :
</p>
              <pre class="screen">
AUTO_DEBSIGN=${AUTO_DEBSIGN:-no}
HOOKDIR=<em class="replaceable"><code>/var/cache/pbuilder/hooks</code></em>
</pre>
            </li>
          </ul>
        </div>
        <p>
D'abord, le système <span class="command"><strong>chroot</strong></span> local de <code class="systemitem">pbuilder</code> doit être initialisé :
</p>
        <pre class="screen">
$ sudo pbuilder create
</pre>
        <p>
Si vous possédez déjà le paquet source terminé, exécutez les commandes
suivantes dans le répertoire contenant les fichiers
<code class="filename"><em class="replaceable"><code>toto</code></em>.orig.tar.gz</code>,
<code class="filename"><em class="replaceable"><code>toto</code></em>.debian.tar.gz</code>, et
<code class="filename"><em class="replaceable"><code>toto</code></em>.dsc</code> pour mettre à jour
le système <span class="command"><strong>chroot</strong></span> de <code class="systemitem">pbuilder</code> et y construire les paquets binaires :
</p>
        <pre class="screen">
$ sudo pbuilder --update
$ sudo pbuilder --build <em class="replaceable"><code>toto_version</code></em>.dsc
</pre>
        <p>
Les paquets nouvellement créés sans signatures GPG sont accessibles en
<code class="filename">/var/cache/pbuilder/result/</code> et n'appartiennent pas au
superutilisateur.
</p>
        <p>
Les signatures GPG des fichiers <code class="filename">.dsc</code> et
<code class="filename">.changes</code> peuvent être créés avec :
</p>
        <pre class="screen">
$ cd /var/cache/pbuilder/result/
$ debsign <em class="replaceable"><code>toto_version_arch</code></em>.changes
</pre>
        <p>
Si vous possédez une arborescence des sources à jour, mais n'avez pas créé
le paquet source correspondant, exécutez plutôt les commandes suivantes dans
le répertoire des sources avec le répertoire <code class="filename">debian</code> :
</p>
        <pre class="screen">
$ sudo pbuilder --update
$ pdebuild
</pre>
        <p>
Vous pouvez vous connecter à l'environnement <span class="command"><strong>chroot</strong></span> avec
la commande <code class="literal">pbuilder --login --save-after-login</code> et le
configurer à votre convenance. Cet environnement peut être sauvegardé en
quittant l'invite de commande avec <code class="literal">^D</code> (Contrôle-D).
</p>
        <p>
La dernière version de la commande <span class="command"><strong>lintian</strong></span> peut être
exécutée dans l'environnement <code class="literal">chroot</code> en utilisant le
script hook
<code class="filename"><em class="replaceable"><code>/var/cache/pbuilder/hooks</code></em>/B90lintian</code>
configuré comme suit : <a href="#ftn.idp39707712" class="footnote" id="idp39707712"><sup class="footnote">[70]</sup></a>
</p>
        <pre class="screen">
#!/bin/sh
set -e
install_packages() {
    apt-get -y --force-yes install "$@"
    }
install_packages lintian
echo "+++ début de lintian +++"
su -c "lintian -i -I --show-overrides /tmp/buildd/*.changes" - pbuilder
# utilisez ceci si vous ne voulez pas que lintian arrête la construction
#su -c "lintian -i -I --show-overrides /tmp/buildd/*.changes; :" - pbuilder
echo "+++ fin de lintian +++"
</pre>
        <p>
Un environnement <code class="literal">sid</code> à jour est nécessaire pour
construire correctement les paquets destinés à <code class="literal">sid</code>. En
pratique, <code class="literal">sid</code> peut parfois être victime de problèmes qui
peuvent rendre non souhaitable la migration de votre système complet. Le
paquet <code class="systemitem">pbuilder</code> peut vous aider à
faire face à ce genre de situation.
</p>
        <p>
Vous pouvez avoir besoin de mettre à jour vos paquets
<code class="literal">stable</code> après sa publication à destination de
<code class="literal">stable-proposed-updates</code>,
<code class="literal">stable/updates</code>, etc. <a href="#ftn.idp39715392" class="footnote" id="idp39715392"><sup class="footnote">[71]</sup></a> Dans ces cas-là, le fait d'utiliser <code class="literal">sid</code> est une
mauvaise excuse pour ne pas les mettre à jour au plus tôt. Le paquet
<code class="systemitem">pbuilder</code> vous permet d'accéder à la
plupart des distributions dérivées de Debian pour la même architecture.
</p>
        <p>
Consultez <a class="ulink" href="http://www.netfort.gr.jp/~dancer/software/pbuilder.html">http://www.netfort.gr.jp/~dancer/software/pbuilder.html</a>, <span class="citerefentry"><span class="refentrytitle">pdebuild</span>(1)</span>, <span class="citerefentry"><span class="refentrytitle">pbuilderrc</span>(5)</span>, et <span class="citerefentry"><span class="refentrytitle">pbuilder</span>(8)</span>.
</p>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="git-buildpackage"/>6.5. Commande <span class="command"><strong>git-buildpackage</strong></span> et similaires</h2>
            </div>
          </div>
        </div>
        <p>
Si les développeurs amont utilisent un système de gestion de version (VCS)
<a href="#ftn.idp39724672" class="footnote" id="idp39724672"><sup class="footnote">[72]</sup></a> pour maintenir leur code source, vous
devriez envisager de l'utiliser. Cela rend la fusion et la sélection
(« cherry-picking ») des correctifs amont plus facile. De nombreux paquets
de scripts d'enrobage sont disponibles pour la construction de paquets
Debian pour chaque système de gestion de version :
</p>
        <div class="itemizedlist">
          <ul class="itemizedlist">
            <li class="listitem">
              <p>
<code class="systemitem">git-buildpackage</code> : assistants pour
les paquets Debian en dépôts Git ;
</p>
            </li>
            <li class="listitem">
              <p>
<code class="systemitem">svn-buildpackage</code> : assistants pour
la maintenance de paquets Debian en dépôt Subversion ;
</p>
            </li>
            <li class="listitem">
              <p>
<code class="systemitem">cvs-buildpackage</code> : scripts pour
paquets Debian en dépôt CVS.
</p>
            </li>
          </ul>
        </div>
        <p>
L'utilisation de <code class="systemitem">git-buildpackage</code>
devient assez populaire parmi les développeurs Debian pour gérer les paquets
Debian avec le serveur Git sur <a class="ulink" href="http://alioth.debian.org/">alioth.debian.org</a>. <a href="#ftn.idp39733856" class="footnote" id="idp39733856"><sup class="footnote">[73]</sup></a> Ce paquet fournit plusieurs commandes pour
<span class="emphasis"><em>automatiser</em></span> les activités d'empaquetage :
</p>
        <div class="itemizedlist">
          <ul class="itemizedlist">
            <li class="listitem">
              <p> <span class="citerefentry"><span class="refentrytitle">git-import-dsc</span>(1)</span> : importer un paquet Debian
existant dans un dépôt Git ;</p>
            </li>
            <li class="listitem">
              <p> <span class="citerefentry"><span class="refentrytitle">git-import-orig</span>()</span> : importer une nouvelle archive
amont dans un dépôt Git ;</p>
            </li>
            <li class="listitem">
              <p> <span class="citerefentry"><span class="refentrytitle">git-dch</span>(1)</span> : générer le journal des
modifications Debian à partir des messages de commit Git ;</p>
            </li>
            <li class="listitem">
              <p> <span class="citerefentry"><span class="refentrytitle">git-buildpackage</span>(1)</span> : construire des paquets Debian à
partir d'un dépôt Git ;</p>
            </li>
            <li class="listitem">
              <p> <span class="citerefentry"><span class="refentrytitle">git-pbuilder</span>()</span> : construire des paquets Debian à
partir d'un dépôt Git en utilisant <span class="command"><strong>pbuilder</strong></span> ou
<span class="command"><strong>cowbuilder</strong></span>.</p>
            </li>
          </ul>
        </div>
        <p>
Ces commandes utilisent trois branches pour suivre les activités
d'empaquetage :
</p>
        <div class="itemizedlist">
          <ul class="itemizedlist">
            <li class="listitem">
              <p> <code class="literal">main</code> pour l'arborescence source de paquet Debian ;</p>
            </li>
            <li class="listitem">
              <p> <code class="literal">upstream</code> pour l'arborescence source amont ;</p>
            </li>
            <li class="listitem">
              <p> <code class="literal">pristine-tar</code> pour l'archive amont générée par l'option
<code class="literal">--pristine-tar</code>.<a href="#ftn.idp39752512" class="footnote" id="idp39752512"><sup class="footnote">[74]</sup></a> </p>
            </li>
          </ul>
        </div>
        <p>
<code class="systemitem">git-buildpackage</code> peut être configuré
dans <code class="filename">~/.gbp.conf</code>. Consultez <span class="citerefentry"><span class="refentrytitle">gbp.conf</span>(5)</span>. <a href="#ftn.idp39757888" class="footnote" id="idp39757888"><sup class="footnote">[75]</sup></a>
</p>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="quickrebuild"/>6.6. Reconstruction rapide</h2>
            </div>
          </div>
        </div>
        <p>
Avec un paquet imposant, vous ne voudrez sans doute pas reconstruire depuis
le début chaque fois que vous faites une petite modification à
<code class="filename">debian/rules</code>. Pour tester, vous pouvez faire un fichier
<code class="filename">.deb</code> sans reconstruire les sources amont comme ceci
<a href="#ftn.idp39769952" class="footnote" id="idp39769952"><sup class="footnote">[76]</sup></a> :
</p>
        <pre class="screen">
$ fakeroot debian/rules binary
</pre>
        <p>
Ou faites simplement comme suit pour voir s'il y a construction ou non :
</p>
        <pre class="screen">
$ fakeroot debian/rules build
</pre>
        <p>
Une fois terminés vos ajustements, souvenez-vous de reconstruire en suivant
la procédure correcte ci-dessus. Vous pouvez être incapable d'envoyer
proprement si vous essayez d'envoyer des fichiers <code class="filename">.deb</code>
construits de cette façon.
</p>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="hierarchy"/>6.7. Hiérarchie des commandes</h2>
            </div>
          </div>
        </div>
        <p>
Voici un résumé sommaire de la façon dont beaucoup de commandes s’assemblent
de manière hiérarchique. Il y a plusieurs manières de faire la même chose :
</p>
        <div class="itemizedlist">
          <ul class="itemizedlist">
            <li class="listitem">
              <p><code class="filename">debian/rules</code> = script du mainteneur pour la
construction du paquet ;</p>
            </li>
            <li class="listitem">
              <p><span class="command"><strong>dpkg-buildpackage</strong></span> = partie principale de l’outil de
construction de paquet ;</p>
            </li>
            <li class="listitem">
              <p><span class="command"><strong>debuild</strong></span> = <span class="command"><strong>dpkg-buildpackage</strong></span> +
<span class="command"><strong>lintian</strong></span> (construction avec des variables d’environnement
vérifiées) ;</p>
            </li>
            <li class="listitem">
              <p><span class="command"><strong>pbuilder</strong></span> = partie principale de l’outil pour
l’environnement chroot de Debian ;</p>
            </li>
            <li class="listitem">
              <p><span class="command"><strong>pdebuild</strong></span> = <span class="command"><strong>pbuilder</strong></span> +
<span class="command"><strong>dpkg-buildpackage</strong></span> (construction dans le chroot) ;</p>
            </li>
            <li class="listitem">
              <p><span class="command"><strong>cowbuilder</strong></span> = accélération de l’exécution de
<span class="command"><strong>pbuilder</strong></span> ;</p>
            </li>
            <li class="listitem">
              <p><span class="command"><strong>git-pbuilder</strong></span> = syntaxe d’utilisation aisée de ligne de
commande pour <span class="command"><strong>pdebuild</strong></span> (utilisée par <span class="command"><strong>gbp
buildpackage</strong></span>) ;</p>
            </li>
            <li class="listitem">
              <p><span class="command"><strong>gbp</strong></span> = gestion des sources Debian dans le dépôt git ;</p>
            </li>
            <li class="listitem">
              <p><span class="command"><strong>gbp buildpackage</strong></span> = <span class="command"><strong>pbuilder</strong></span> +
<span class="command"><strong>dpkg-buildpackage</strong></span> + <span class="command"><strong>gbp</strong></span>.</p>
            </li>
          </ul>
        </div>
        <p>
Bien que les commandes de haut niveau telles que <span class="command"><strong>gbp
buildpackage</strong></span> et <span class="command"><strong>pbuilder</strong></span> garantissent un
environnement de construction de paquet  parfait, il est essentiel de
comprendre comment les commandes de bas niveau, telles que
<code class="filename">debian/rules</code> et <span class="command"><strong>dpkg-buildpackage</strong></span>,
sont exécutées en dessous.
</p>
      </div>
      <div class="footnotes">
        <br/>
        <hr/>
        <div id="ftn.idp39606512" class="footnote">
          <p><a href="#idp39606512" class="para"><sup class="para">[64] </sup></a>
Cette clef GPG doit être signée par un développeur Debian pour être
connectée au réseau de confiance et doit être enregistrée dans le <a class="ulink" href="http://keyring.debian.org">trousseau Debian</a>. Cela permet à vos paquets d'être
acceptés dans l'archive Debian. Consultez la page de <a class="ulink" href="http://keyring.debian.org/creating-key.html">création d'une nouvelle clef GPG</a> et le <a class="ulink" href="http://wiki.debian.org/Keysigning">wiki Debian à propos de la signature de clef</a>.
</p>
        </div>
        <div id="ftn.idp39622032" class="footnote">
          <p><a href="#idp39622032" class="para"><sup class="para">[65] </sup></a> Il est possible de ne pas appliquer les correctifs <span class="command"><strong>quilt</strong></span>
du format source <code class="literal">3.0 (quilt)</code> à la fin de l'extraction
avec l'option <code class="literal">--skip-patches</code>. Sinon, il est aussi
possible d'exécuter <code class="literal">dquilt pop -a</code> après l'extraction
normale.  </p>
        </div>
        <div id="ftn.idp39645200" class="footnote">
          <p><a href="#idp39645200" class="para"><sup class="para">[66] </sup></a> Le véritable réseau de serveurs d'empaquetage automatique a un
fonctionnement autrement plus compliqué que celui présenté ici. De tels
détails sortent du cadre de ce document.  </p>
        </div>
        <div id="ftn.idp39663088" class="footnote">
          <p><a href="#idp39663088" class="para"><sup class="para">[67] </sup></a> contrairement à celui du paquet <code class="systemitem">pbuilder</code>, l'environnement
<span class="command"><strong>chroot</strong></span> du paquet <code class="systemitem">sbuild</code> utilisé par les serveurs d'empaquetage
automatique n'est pas forcément minimal et plusieurs paquets peuvent rester
installés.  </p>
        </div>
        <div id="ftn.idp39680192" class="footnote">
          <p><a href="#idp39680192" class="para"><sup class="para">[68] </sup></a> Comme le paquet <code class="systemitem">pbuilder</code> est en
constante évolution, vous devriez vérifier les possibilités réelles de la
configuration en consultant la dernière documentation officielle.</p>
        </div>
        <div id="ftn.idp39682880" class="footnote">
          <p><a href="#idp39682880" class="para"><sup class="para">[69] </sup></a>Consultez <a class="ulink" href="http://buildd.debian.org/">http://buildd.debian.org/</a> pour obtenir plus de renseignements sur
le service de construction automatique de paquets Debian.</p>
        </div>
        <div id="ftn.idp39707712" class="footnote">
          <p><a href="#idp39707712" class="para"><sup class="para">[70] </sup></a> Cela suppose que <code class="literal">HOOKDIR=/var/cache/pbuilder/hooks</code> est
déjà configuré. De nombreux exemples de scripts hook sont disponibles dans
le répertoire <code class="filename">/usr/share/doc/pbuilder/examples</code>.  </p>
        </div>
        <div id="ftn.idp39715392" class="footnote">
          <p><a href="#idp39715392" class="para"><sup class="para">[71] </sup></a> Il existe des restrictions pour de telles mises à jour de paquet
<code class="literal">stable</code>.
</p>
        </div>
        <div id="ftn.idp39724672" class="footnote">
          <p><a href="#idp39724672" class="para"><sup class="para">[72] </sup></a>Consultez <a class="ulink" href="http://www.debian.org/doc/manuals/debian-reference/ch10#_version_control_systems">Systèmes de contrôle de version</a>
pour obtenir plus de renseignements.</p>
        </div>
        <div id="ftn.idp39733856" class="footnote">
          <p><a href="#idp39733856" class="para"><sup class="para">[73] </sup></a>Le <a class="ulink" href="http://wiki.debian.org/Alioth">wiki Debian sur Alioth</a>
documente la façon d'utiliser le service <a class="ulink" href="http://alioth.debian.org/">alioth.debian.org</a>.</p>
        </div>
        <div id="ftn.idp39752512" class="footnote">
          <p><a href="#idp39752512" class="para"><sup class="para">[74] </sup></a>L'option <code class="literal">--pristine-tar</code> invoque la commande
<span class="command"><strong>pristine-tar</strong></span> qui peut générer une copie exacte de
l'archive amont d'origine en n'utilisant qu'un petit fichier de delta
binaire et le contenu de l'archive amont, qui est normalement gardé dans une
branche <code class="literal">upstream</code> du système de gestion de version. </p>
        </div>
        <div id="ftn.idp39757888" class="footnote">
          <p><a href="#idp39757888" class="para"><sup class="para">[75] </sup></a> Voici quelques ressources disponibles sur la toile pour les utilisateurs
avancés :  </p>
          <div class="itemizedlist">
            <ul class="itemizedlist">
              <li class="listitem">
                <p> Construction de paquets Debian avec git-buildpackage
(<code class="filename">/usr/share/doc/git-buildpackage/manual-html/gbp.html</code>) ;</p>
              </li>
              <li class="listitem">
                <p> <a class="ulink" href="https://honk.sigxcpu.org/piki/development/debian_packages_in_git/">Paquets Debian avec Git</a> ; </p>
              </li>
              <li class="listitem">
                <p> <a class="ulink" href="http://www.eyrie.org/~eagle/notes/debian/git.html">Utilisation de Git pour l'empaquetage
Debian</a> ; </p>
              </li>
              <li class="listitem">
                <p> <a class="ulink" href="http://git-dpm.alioth.debian.org/">git-dpm : paquets Debian en gestionnaire
Git</a> ; </p>
              </li>
              <li class="listitem">
                <p> <a class="ulink" href="http://git.debian.org/?p=collab-maint/topgit.git;a=blob_plain;f=debian/HOWTO-tg2quilt;hb=HEAD">Utilisation de TopGit pour créer un ensemble quilt
pour l'empaquetage Debian</a>. </p>
              </li>
            </ul>
          </div>
        </div>
        <div id="ftn.idp39769952" class="footnote">
          <p><a href="#idp39769952" class="para"><sup class="para">[76] </sup></a> Les variables d'environnement qui devraient normalement être configurées
correctement à cette étape ne sont pas configurées par cette méthode. Ne
créez jamais de vrais paquets pour l'envoi avec cette méthode <span class="strong"><strong>rapide</strong></span>.  </p>
        </div>
      </div>
    </div>
    <div class="navfooter">
      <hr/>
      <table width="100%" summary="Navigation footer">
        <tr>
          <td align="left"><a accesskey="p" href="dother.fr.html"><img src="images/prev.png" alt="Précédent"/></a> </td>
          <td align="center"> </td>
          <td align="right"> <a accesskey="n" href="checkit.fr.html"><img src="images/next.png" alt="Suivant"/></a></td>
        </tr>
        <tr>
          <td align="left" valign="top">Chapitre 5. Autres fichiers dans le répertoire <code class="filename">debian</code> </td>
          <td align="center">
            <a accesskey="h" href="index.fr.html">
              <img src="images/home.png" alt="Sommaire"/>
            </a>
          </td>
          <td align="right" valign="top"> Chapitre 7. Contrôle des erreurs du paquet</td>
        </tr>
      </table>
    </div>
  </body>
</html>
